// 6.05.2007   
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//|                                              BrainTrend1Stop.mq4 |
//|                                          BrainTrend Black edition|
//|                                      http://www.braintrading.com |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
#property copyright "BrainTrend Black edition"
#property link      "http://www.braintrading.comt"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Aqua
//---- input parameters

extern int       Simbol    =119;
extern int       CountBars =500;
extern int       EnableAlerts=0;
extern int       SignalID    =0;
extern int SSAPrice                =  PRICE_CLOSE;
extern int SSALag                  =  25;
extern int SSANumberOfComputations =   2;
extern int SSANumberOfBars         = 300;
extern int FirstBar                = 300; 

extern int       f            = 7;
extern int       s            = 1.5;
extern int       x1           = 80;
extern int       x2           = 20;
extern int       d            = 2.3;
extern int    StoKPeriod                = 14;
extern int    StoDPeriod                = 3;
extern int    StoSlowing                = 3;
extern int    StoMAMethod               = 0;
extern int    StoPriceField             = 1;
extern int    stoKDmode                 = 0;
extern int    JMALen                    = 8;
extern int    JMAphase                  = 0;
extern int    BarCount                  = 900;

//---- buffers
double Ind_Buffer1[];
double Ind_Buffer2[];
//----
int limit,p;
double val1,val2,val3,r;
double value2,value3,value4,value5,value6,Range,range1,a1,bs,bs1;
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator initialization function                         |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int init()
  {
//---- indicator 0
   SetIndexStyle (0,DRAW_ARROW);
   SetIndexArrow (0,Simbol);
   SetIndexBuffer(0,Ind_Buffer1);
   SetIndexEmptyValue(0,0.0);
//---- indicator 1  
   SetIndexStyle (1,DRAW_ARROW);
   SetIndexArrow( 1,Simbol);
   SetIndexBuffer(1,Ind_Buffer2);
   SetIndexEmptyValue(1,0.0);
//----
   string short_name;
   short_name="BrainTrend1Stop";
   IndicatorShortName(short_name);
   SetIndexLabel(0,""+short_name+"_SELL");
   SetIndexLabel(1,""+short_name+"_BUY" );
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//----
   s=1.5; d=2.3; f=7; x1 = 80; x2 = 20;
//----
   return(0);
  }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator iteration function                              |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int start()
  {
   double CloseVal, CloseVal2, HighVal, LowVal;
   int shift,counted_bars=IndicatorCounted();
//---- 
   if (Bars < 11)return(0);
   if (CountBars > Bars-1-11)CountBars=Bars-1-11;
//----  
   limit = CountBars; p=0; //-counted_bars-1
//----  
   shift=limit;
//----   
   while(shift>=0)    
      {
      Range  = iATR(NULL,0,f, shift)/ d;
      range1 = iATR(NULL,0,10,shift)* s;
      value2 = iCustom(NULL,0,"JMA_Stochastic",StoKPeriod,StoDPeriod,StoSlowing,StoMAMethod,StoPriceField,stoKDmode,JMALen,JMAphase,BarCount,0,shift);
      
      CloseVal  = iCustom(NULL,0,"SSA end-pointed",SSAPrice,  SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,0,shift);
      CloseVal2 = iCustom(NULL,0,"SSA end-pointed",SSAPrice,  SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,0,shift + 2);
      HighVal   = iCustom(NULL,0,"SSA end-pointed",PRICE_HIGH,SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,0,shift);
      LowVal    = iCustom(NULL,0,"SSA end-pointed",PRICE_LOW, SSALag,SSANumberOfComputations,SSANumberOfBars,FirstBar,0,shift);
//---- 
      val1 = 0;
      val2 = 0;
      val3 = MathAbs(CloseVal - CloseVal2);
      if (value2 < x2 && val3 > Range&& p != 1 )
         {
         value3 = HighVal + range1 / 4;
         val1 = value3;
         p = 1; 
         r = val1; 
         bs = r; 
         Ind_Buffer1[shift]=val1; 
         Ind_Buffer2[shift]=0;       
         }
      if (value2 > x1 && val3 > Range && p != 2 ) 
         {
         value3 = LowVal - range1/ 4;
         val2 = value3;
         p = 2;
         r = val2; 
         bs = r; 
         Ind_Buffer1[shift]=0;
         Ind_Buffer2[shift]=val2;   
         }
      value4 = HighVal + range1;
      value5 = LowVal - range1;
      if (val1 == 0 && val2 == 0 && p == 1 )
         {
         if (value4 < r)
          {
          r = value4; 
          bs = r; 
          Ind_Buffer1[shift]=r; 
          Ind_Buffer2[shift]=0;
          }
         else
          {
        //r = r; 
          bs = r; 
          Ind_Buffer1[shift]=r; 
          Ind_Buffer2[shift]=0;}
          }
         if( val1 == 0 && val2 == 0 && p == 2 && value5 >  r)                   
          {
          r = value5; 
          bs = r; 
          Ind_Buffer1[shift]=0; 
          Ind_Buffer2[shift]=r;
          }
         if( val1 == 0 && val2 == 0 && p == 2 && value5 <= r)        
          {
        //r = r; 
          bs = r; 
          Ind_Buffer1[shift]=0; 
          Ind_Buffer2[shift]=r;
          }      
         shift--;
        }
   
   if (EnableAlerts == 1 && bs > 0 && bs != bs1)
      {
      bs1 = bs;
      a1 = FileOpen("alert1" + SignalID,";");
      FileWrite(a1,"BT1Stop value for " , Symbol() , " is " , bs , " Current Close=" , Close[0] , " M" + Period());
      FileClose(a1);
      }
//----
   return(0);
  }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+